#pragma once
#include "Vector.h"

class Frustum
{
public:
	Frustum();
	void Setup(float fov, float aspect, float begin, float end);
	void ExtractPlanes(Vec3 pos, Vec3 look, Vec3 up);
	void ExtractPlanes();
	void SetMatrices(float* p, float* v);

	float model[16];
	float proj[16];
	float clip[16];

	float planes[6][4];
	float mFov, mAspect, mNear, mFar;

	bool BoundsInFrustum(Vec3 mins, Vec3 maxs);
	bool FrustraInFrustum(Vec3 points[9]);

	float External_view[16];
	float External_proj[16];

};