#include "FontWriter.h"
#include "Engine.h"
bool PruneFontWriters(FontWriter& FW)
{
	FW.Update();
	if(FW.miLife<=0)
		return true;
	return false;
}
void FontWriter::Spawn(Vec2 P, char* txt, int freq, int life)
{
	mPos = P;
	mText = txt;
	miFrequency = freq;
	miLife = life;
	miLength = 0;
	clock = 0;
}
void FontWriter::Update()
{
	clock++;
	while(clock>=miFrequency)
	{
		clock = 0;
		miLength++;
		if(miLength>=mText.length())
			break;
	}

	if(miLength>=mText.length())
		miLife--;
}
void FontWriter::Render(const float interp)
{
	std::string TEXT;
	TEXT.assign(mText.c_str(),miLength);
	gpEng->mFont1.SetAlignment(ALIGN_CENTER);
	gpEng->mFont1.Print((char*)TEXT.c_str(),mPos.x,mPos.y);
}
