#pragma once
#include "Vector.h"
#include <vector>

class SpriteSheet
{
public:
	SpriteSheet();
	void Split(unsigned int img, int w, int h, int imgWidth, int imgHeight);
	Vec2 GetTileUV(int ID);
	Vec2 mUVsize;
	Vec2 mFrameSize;
	int ImgWidth, ImgHeight;
	unsigned int mImg;
	int NumFrames;
private:
	int width, height;
	std::vector<Vec2> mUV;//list of UV coords for the sheet
};